#declare HouseDemo_debug = 1;

#if(0)

#declare Rad_Quality = 5; //2

global_settings {
  assumed_gamma 1

#switch (Rad_Quality)
 #case (1)
  radiosity {             // --- Settings 1 (fast) ---
    pretrace_start 0.08
    pretrace_end   0.02
    count 50
    error_bound 0.5
    recursion_limit 1
  }
 #break
 #case (2)
  radiosity {             // --- Settings 2 (medium quality) ---
    pretrace_start 0.08
    pretrace_end   0.01
    count 120
    error_bound 0.25
    recursion_limit 1
    brightness .55
  }
 #break
 #case (3)
  radiosity {             // --- Settings 3 (high quality) ---
    pretrace_start 0.08
    pretrace_end   0.005
    count 400
    error_bound 0.1
    recursion_limit 1
    brightness .55
  }
 #break
 #case (4)
  radiosity {             // --- Settings 4 (medium quality, recursion_limit 2) ---
    pretrace_start 0.08
    pretrace_end   0.005
    count 350
    error_bound 0.15
    recursion_limit 2
  }
 #break
 #case (5)
  radiosity {             // --- fc sec high/medium compromize ---
    pretrace_start 0.08
    pretrace_end   0.005
    count 300
    error_bound 0.015
    recursion_limit 2
    brightness .55
  }
 #break
 #end

}

#end


#if(HouseDemo_debug)

/********************************************************/
/* Camera & Lights */
/********************************************************/

#declare cx = 7;
#declare cy = .6;
#declare cz = 9;

#declare Cam_location_vec = <cx, cy, cz>;
#declare Cam_look_at_vec = <0, cy, 0>;
#declare Zoom = 1;
#declare light_location_vec = <cx, cy, cz>;
#declare light_location_vec = <1000, 2000, 3000>;


#declare G_debug = 1;
#declare G_debug_L = 10;
#declare G_debug_R = 0.016;

#include "FCcamera.INC"
background { rgb<.45,  .45,  .55> }

/*indicate that debug i set */
#debug  "\n "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug    " HouseDemo is set for debug "
#debug  "\n * * * * * * * * * * * * * * "
#debug  "\n "
#debug  "\n "



#end /* if debug */
/******************************************************/
/* Object Definition */

#macro HouseDemoMac (p_W, p_H, p_T,
           p_x0, p_y0, p_z0,
           p_Txt, p_DoTxt)


//-----------------------------------------
// Var 

#local m = .172;

#local BlockW = 15*m;
#local BlockH = 10*m;
#local BlockT = 10*m;
#local BlockV = <BlockW, BlockH, BlockT>;

#local SecW = 1.5*m;
#local SecH = 2.5*m;
#local SecT = .5*m;

#local NumH = 6;

// - - - - - - - - - - - - - - - - - - - - - - - -

#local VertArrObj =
mesh{

#local Count = NumH-1;
#local I = 0;
#while ( I <= Count )

#local dd = 0.000051*m; 

#local bW = SecW-dd*2;
#local bH = SecH-dd*2;
#local bT = SecT;

#local bX0 = 0;
#local bY0 = SecH*I+dd;
#local bZ0 = -SecT/2;

#local DE = SecW/2.95;
#local DT = SecT*.5;

#include "MeshMod.tch"



#local I = I + 1;
#end


}

#local VertArrOutObj =
mesh{

#local Count = NumH-1;
#local I = 0;
#while ( I <= Count )

#local dd = 0.000051*m; 

#local bW = SecW-dd*2;
#local bH = SecH-dd*2;
#local bT = SecT;

#local bX0 = 0;
#local bY0 = SecH*I+dd;
#local bZ0 = -SecT/2;

#local DE = SecW/2.5;
#local DT = -SecT*.67;

#include "MeshMod.tch"



#local I = I + 1;
#end


}

//-----------------------------------------
// Main 

 union{


//object{ VertArrObj }

//- - - - - - - - - - - - - - - - - - - - -
// Rect Arr

#local RectW = SecW*8+m*.4;
#local RectT = SecW*6+m*.4;

#local RectNumW = 8;
#local RectNumT = 6;

#local RectDW = SecW; //RectW/(RectNumW-1);
#local RectDT = SecW;

#local RectObj = 

object{ VertArrObj }


// W
#local ArrNum = RectNumW;
#local ArrDX  = RectDW;
#local ArrW   = (ArrNum-1)*ArrDX;

#local Count = ArrNum-1;
#local I = 0;
#while ( I <= Count )

      #local ArrTrn = transform{ translate<ArrDX*I-ArrW/2, 0, RectT/2> }
      object{ RectObj
              transform ArrTrn
            }

      #local ArrTrn = transform{ translate<ArrDX*I-ArrW/2, 0, -RectT/2> }
      object{ RectObj
              transform ArrTrn
            }

#local I = I + 1;
#end

// T
#local ArrJNum = RectNumT;
#local ArrJDX  = RectDT;
#local ArrJW   = (ArrJNum-1)*ArrJDX;

#local CountJ = ArrJNum-1;
#local J = 0;
#while ( J <= CountJ )

      #local ArrJTrn = transform{ translate< RectW/2, 0, ArrJDX*J-ArrJW/2> }
      object{ RectObj
              rotate y*90
              transform ArrJTrn
            }

      #local ArrJTrn = transform{ translate<-RectW/2, 0, ArrJDX*J-ArrJW/2> }
      object{ RectObj
              rotate y*-90
              transform ArrJTrn
            }

#local J = J + 1;
#end


//- - - - - - - - - - - - - - - - - - - - -
// Rect Arr

#local RectW = SecW*8+m*.4;
#local RectT = SecW*6+m*.4;

#local RectNumW = 9;
#local RectNumT = 7;

#local RectDW = SecW; //RectW/(RectNumW-1);
#local RectDT = SecW;

#local RectObj = 
#local bV = <.2*m, SecH*NumH, .2*m>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>}


// W
#local ArrNum = RectNumW;
#local ArrDX  = RectDW;
#local ArrW   = (ArrNum-1)*ArrDX;

#local Count = ArrNum-1;
#local I = 0;
#while ( I <= Count )

      #local ArrTrn = transform{ translate<ArrDX*I-ArrW/2, 0, RectT/2> }
      object{ RectObj
              transform ArrTrn
            }

      #local ArrTrn = transform{ translate<ArrDX*I-ArrW/2, 0, -RectT/2> }
      object{ RectObj
              transform ArrTrn
            }

#local I = I + 1;
#end

// T
#local ArrJNum = RectNumT;
#local ArrJDX  = RectDT;
#local ArrJW   = (ArrJNum-1)*ArrJDX;

#local CountJ = ArrJNum-1;
#local J = 0;
#while ( J <= CountJ )

      #local ArrJTrn = transform{ translate< RectW/2, 0, ArrJDX*J-ArrJW/2> }
      object{ RectObj
              rotate y*90
              transform ArrJTrn
            }

      #local ArrJTrn = transform{ translate<-RectW/2, 0, ArrJDX*J-ArrJW/2> }
      object{ RectObj
              rotate y*-90
              transform ArrJTrn
            }

#local J = J + 1;
#end


// floors

mesh{

#local Count = 5+1;
#local I = 0;
#while ( I <= Count )


#local bW = RectW-m;
#local bH = .1*m;
#local bT = RectT-m;

#local bX0 = 0;
#local bY0 = SecH*I-bH;
#local bZ0 = 0;

#include "Mesh.tch"


#local I = I + 1;
#end



}




#local Count = 12-1;
#local I = 0;
#while ( I <= Count )

object{ VertArrOutObj translate<0,SecH*NumH,SecW*2> rotate y*360/12*I  }

#local bV = <.4*m, SecH*NumH, .4*m>;
#local bW = bV.x;
#local bH = bV.y;
#local bT = bV.z;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>  translate<0,SecH*NumH,SecW*2> rotate y*360/12*(I+.5) }


#local I = I + 1;
#end




      #if (p_DoTxt) 
           texture{ p_Txt }
      #end

      translate<p_x0, p_y0, p_z0>
 }


#end

/******************************************************/
/* if not used as inc then draw object */
#if(HouseDemo_debug)

#local l_W = 1;
#local l_H = 2;
#local l_T = 3;

#local l_Txt = texture{ pigment{rgb .7}   finish{ ambient .025 diffuse .975 } }
#local l_DoTxt = 1;

#local HouseDemoObj =
HouseDemoMac
      (l_W, l_H, l_T,
       0, 0, 0,
       l_Txt, l_DoTxt)

object{ HouseDemoObj } 

#local bW = 2000;
#local bH = -2;
#local bT = 2000;
box{<-bW/2, 0, -bT/2>, <bW/2, bH, bT/2>
	texture{ pigment {rgb .8 }  finish{ ambient .025 diffuse .975 }  }
    }
#end

/******************************************************/
/*
The Call


   #include "HouseDemo.Inc"






















*/
/*******************************************************/
